#pragma noroot
#include "SLED.h"
#include "SLED.FX2.h"
#include "SLED.Games.h"

KEYWORD Commands[]={
    {"APPLICATIONNAME", ApplicationName,NO_ARGS},
    {"APPNAME",         ApplicationName,NO_ARGS},
    {"BACKGROUNDCOLOR", BackgroundColor,0},
    {"BALLS",           Balls,          0},
    {"CASCADESCROLL",   CascadeScroll,  GRABES_INPUT | USES_MOVE_IT | NO_ARGS},
    {"CHECKERBOARD",    CheckerBoard,   0},
    {"CLEAR",           Clear,          NO_ARGS},
    {"CLEARMASK",       ClearMask,      NO_ARGS},
    {"COLOR",           Color,          0},
    {"COLORBACKGROUND", BackgroundColor,0},
    {"DATE",            Date,           NO_ARGS},
    {"DELAY",           WaitCommand,    0},
    {"DOWNSCROLL",      Down,           GRABES_INPUT | NO_ARGS},
    {"DROP",            Drop,           GRABES_INPUT | NO_ARGS},
    {"ENDLOOP",         Next,           NO_ARGS},
    {"EASTEREGG1",      EasterEgg1,     NO_ARGS},
    {"EASTEREGG2",      EasterEgg2,     NO_ARGS},
    {"ERASE",           Clear,          NO_ARGS},
    {"FADE",            Fade,           GRABES_INPUT | NO_ARGS},
    {"FALL",            Fall,           NO_ARGS},
    {"FENCE",           Fence,          GRABES_INPUT | NO_ARGS},
    {"FLASH",           Flash,          0},
    {"FLUSH",           SLEDFlush,      NO_ARGS},
    {"FONT",            SetLEDFont,     0},
    {"FOR",             For,            0},
    {"FRAME",           Frame,          0},
    {"HORIZONTAL",      Horizontal,     GRABES_INPUT | USES_MOVE_IT | NO_ARGS},
    {"INVERSE",         Inverse,        NO_ARGS},
    {"INVERT",          Inverse,        NO_ARGS},
/*  {"IRIS",            Iris,           GRABES_INPUT},*/
    {"JUSTIFICATION",   SetJustification, 0},
/*	{"Chaos",           Chaos,          GRABES_INPUT | NO_ARGS}, */
    {"LASERS",          Lasers,         GRABES_INPUT},
    {"LEFT",            Left,           GRABES_INPUT | NO_ARGS},
    {"LEFTRIGHT",       LeftRight,      GRABES_INPUT | USES_MOVE_IT},
    {"LEFTSCROLL",      Left,           GRABES_INPUT | NO_ARGS},
    {"LOOP",            For,            0},
    {"MARQUEE",         Marquee,        0},
    {"MESH",            LeftRight,      GRABES_INPUT | USES_MOVE_IT},
    {"NEXT",            Next,           NO_ARGS},
    {"NUDGEDOWN",       NudgeDown,      NO_ARGS},
    {"NUDGELEFT",       NudgeLeft,      NO_ARGS},
    {"NUDGERIGHT",      NudgeRight,     NO_ARGS},
    {"NUDGEUP",         NudgeUp,        NO_ARGS},
    {"PACMAN",          PacMan,         NO_ARGS},
    {"PAUSE",           WaitCommand,    0},
    {"PLAY",            PlayCommand,    0},
    {"PRINT",           Print,          GRABES_INPUT | NO_ARGS},
    {"PRINTER",         Printer,        GRABES_INPUT | NO_ARGS},
    {"QIX",             Qix,            0},
    {"SCAN",            Scan,           GRABES_INPUT | NO_ARGS},
    {"SCROLLDOWN",      Down,           GRABES_INPUT | NO_ARGS},
    {"SCROLLLEFT",      Left,           GRABES_INPUT | NO_ARGS},
    {"SCROLLOFF",       ScrollOff,      NO_ARGS},
    {"SCROLLUP",        Up,             GRABES_INPUT | NO_ARGS},
    {"SETFONT",         SetLEDFont,     0},
    {"SETJUSTIFICATION", SetJustification, 0},
    {"SETMASK",         SetMask,        NO_ARGS},
    {"SHADOWON",        ShadowOn,       0},
    {"SHADOWOFF",       ShadowOff,      NO_ARGS},
    {"SLIDE",           Slide,          GRABES_INPUT | USES_MOVE_IT | NO_ARGS},
    {"SO",              ScrollOff,      NO_ARGS},
    {"SPLITVERTICAL",   SplitVertical,  GRABES_INPUT | USES_MOVE_IT | NO_ARGS},
    {"SPLITHORIZONTAL", SplitHorizontal,GRABES_INPUT | USES_MOVE_IT | NO_ARGS},
    {"STACKUP",         StackUp,        GRABES_INPUT | NO_ARGS},
    {"STATIC",          Static,         0},
    {"SWEEP",           Sweep,          GRABES_INPUT | NO_ARGS},
    {"TIME",            Time,           0},
    {"TIMECHANGEWAIT",  WaitForTimeChange, NO_ARGS},
    {"TIMESINCE",       TimeUntil,      0},
    {"TIMEUNTIL",       TimeUntil,      0},
    {"TRACE",           Trace,          GRABES_INPUT | USES_MOVE_IT | NO_ARGS},
    {"TRIM",            Trim,           GRABES_INPUT | USES_MOVE_IT | NO_ARGS},
    {"UPSCROLL",        Up,             GRABES_INPUT | NO_ARGS},
    {"UPDOWN",          UpDown,         GRABES_INPUT | USES_MOVE_IT},
/*  {"V",               V,              GRABES_INPUT | USES_MOVE_IT | NO_ARGS},*/
    {"VERTICAL",        Vertical,       GRABES_INPUT | USES_MOVE_IT | NO_ARGS},
    {"VBLIND",          VBlind,         GRABES_INPUT | USES_MOVE_IT | NO_ARGS},
    {"WAIT",            WaitCommand,    0},
    {"WAITFORTIMECHANGE", WaitForTimeChange, NO_ARGS},
    {"WIPE",            WipeCommand,    GRABES_INPUT},
    {NULL, 0}
};

KEYWORD Fonts[]={
    {"FIXEDNUMBERS",   NULL,   FONT_FIXEDNUMBERS},
    {"NORMAL",  NULL,   FONT_NORMAL},
    {NULL,      NULL,   0}
};

KEYWORD Bools[]={
    {"0",       NULL,   FALSE},
    {"1",       NULL,   TRUE},
    {"FALSE",   NULL,   FALSE},
    {"NO",      NULL,   FALSE},
    {"ON",      NULL,   TRUE},
    {"OFF",     NULL,   FALSE},
    {"TRUE",    NULL,   TRUE},
    {"YES",     NULL,   TRUE},
    {NULL,      NULL,   0}
};

KEYWORD Justifications[]={
    {"CENTER",  NULL,   KW_CENTER},
    {"LEFT",    NULL,   KW_LEFT},
    {"RIGHT",   NULL,   KW_RIGHT},
    {NULL,      NULL,   0}
};

KEYWORD Directions[]={
    {"DOWN",    NULL,   FORWARD},
    {"FORWARD", NULL,   FORWARD},
    {"IN",      NULL,   REVERSE},
    {"LEFT",    NULL,   REVERSE},
    {"OUT",     NULL,   FORWARD},
    {"REVERSE", NULL,   REVERSE},
    {"RIGHT",   NULL,   FORWARD},
    {"UP",      NULL,   REVERSE},
    {NULL,      NULL,   0}
};

KEYWORD WipeDirections[]={
    {"DOWN",    NULL,   KW_DOWN},
    {"LEFT",    NULL,   KW_LEFT},
    {"RIGHT",   NULL,   KW_RIGHT},
    {"UP",      NULL,   KW_UP},
    {NULL,      NULL,   0}
};

KEYWORD MoveModes[]={
    {"ALLSCROLL",   NULL,   ScrollBoth},
    {"BORDERWIPE",  NULL,   WipeBorder},
    {"BOTHSCROLL",  NULL,   ScrollBoth},
    {"NEWSCROLL",   NULL,   ScrollNew},
    {"OLDSCROLL",   NULL,   ScrollOld},
    {"SCROLLALL",   NULL,   ScrollBoth},
    {"SCROLLNEW",   NULL,   ScrollNew},
    {"SCROLLOLD",   NULL,   ScrollOld},
    {"SCROLLBOTH",  NULL,   ScrollBoth},
    {"WIPE",        NULL,   Wipe},
    {"WIPEBORDER",  NULL,   WipeBorder},
    {"WIPENOBORDER",NULL,   Wipe},
    {NULL,          NULL,   0}
};

KEYWORD Colors[]={
    {"BLACK",   NULL,   CLR_BLACK},
    {"BLUE",    NULL,   CLR_BLUE},
    {"DARKRED", NULL,   CLR_DARKRED},
    {"DARKGREEN",NULL,  CLR_DARKGREEN},
    {"GREEN",   NULL,   CLR_GREEN},
    {"NORMAL",  NULL,   CLR_ON},
    {"OFF",     NULL,   CLR_OFF},
    {"ON",      NULL,   CLR_ON},
    {"RED",     NULL,   CLR_RED},
    {"WHITE",   NULL,   CLR_WHITE},
    {"YELLOW",  NULL,   CLR_YELLOW},
    {NULL,      NULL,   0}
};

int CharWidths[]={
/*   ! " # $ % & ' ( ) * + , - . / 0 1 2 3 4 5 6 7 8 9 : ; < = > ? */
   3,2,3,5,5,4,4,2,3,3,5,3,2,3,1,4,4,3,4,4,4,4,4,4,4,4,1,2,4,4,4,4,

/* @ A B C D E F G H I J K L M N O P Q R S T U V W X Y Z [ \ ] ^ _ */
   4,4,4,4,4,4,4,4,4,3,4,4,4,5,4,4,4,4,4,4,5,4,3,5,3,3,4,3,4,3,3,3,

/* ` a b c d e f g h i j k l m n o p q r s t u v w x y z { | } ~   */
   3,4,4,4,4,4,4,4,4,3,4,4,3,5,4,4,4,4,4,4,3,4,3,5,3,4,4,3,2,3,5};


char LEDFont[][CharHeight][MaxCharWidth]={
    {{0x00,0x00,0x00}, /*   */
     {0x00,0x00,0x00},
     {0x00,0x00,0x00},
     {0x00,0x00,0x00} ,
     {0x00,0x00,0x00},
     {0x00,0x00,0x00},
     {0x00,0x00,0x00},
     {0x00,0x00,0x00}},
    {{0x00,0xFF}, /* ! */
     {0x00,0xFF},
     {0x00,0xFF},
     {0x00,0xFF} ,
     {0x00,0xFF},
     {0x00,0x00},
     {0x00,0xFF},
     {0x00,0x00,0x00,0x00}},
    {{0xFF,0x00,0xFF}, /* " */
     {0xFF,0x00,0xFF},
     {0xFF,0x00,0xFF},
     {0x00,0x00,0x00} ,
     {0x00,0x00,0x00},
     {0x00,0x00,0x00},
     {0x00,0x00,0x00},
     {0x00,0x00,0x00}},
    {{0x00,0xFF,0x00,0xFF,0x00}, /* # */
     {0x00,0xFF,0x00,0xFF,0x00},
     {0xFF,0xFF,0xFF,0xFF,0xFF},
     {0x00,0xFF,0x00,0xFF,0x00} ,
     {0xFF,0xFF,0xFF,0xFF,0xFF},
     {0x00,0xFF,0x00,0xFF,0x00},
     {0x00,0xFF,0x00,0xFF,0x00},
     {0x00,0x00,0x00,0x00,0x00}},

    {{0x00,0xFF,0xFF,0xFF,0x00}, /* $ */
     {0xFF,0x00,0xFF,0x00,0xFF},
     {0xFF,0x00,0xFF,0x00,0x00},
     {0x00,0xFF,0xFF,0xFF,0x00},
     {0x00,0x00,0xFF,0x00,0xFF},
     {0xFF,0x00,0xFF,0x00,0xFF},
     {0x00,0xFF,0xFF,0xFF,0x00},
     {0x00,0x00,0xFF,0x00,0x00}},

    {{0xFF,0xFF,0x00,0xFF}, /* % */
     {0xFF,0xFF,0x00,0xFF},
     {0x00,0x00,0xFF,0x00},
     {0x00,0x00,0xFF,0x00} ,
     {0x00,0xFF,0x00,0x00},
     {0xFF,0x00,0xFF,0xFF},
     {0xFF,0x00,0xFF,0xFF},
     {0x00,0x00,0x00,0x00}},
    {{0x00,0xFF,0x00,0x00}, /* & */
     {0xFF,0x00,0xFF,0x00},
     {0x00,0xFF,0x00,0x00},
     {0xFF,0x00,0xFF,0x00,0xFF} ,
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0x00,0x00,0xFF},
     {0x00,0xFF,0xFF,0x00,0xFF},
     {0x00,0x00,0x00,0x00}},
    {{0x00,0xFF}, /* ' */
     {0x00,0xFF},
     {0x00,0xFF},
     {0x00,0x00} ,
     {0x00,0x00},
     {0x00,0x00},
     {0x00,0x00},
     {0x00,0x00}},
    {{0x00,0x00,0xFF}, /* ( */
     {0x00,0xFF,0x00},
     {0x00,0xFF,0x00},
     {0x00,0xFF,0x00} ,
     {0x00,0xFF,0x00},
     {0x00,0xFF,0x00},
     {0x00,0x00,0xFF},
     {0x00,0x00,0x00}},
    {{0xFF,0x00,0x00}, /* ) */
     {0x00,0xFF,0x00},
     {0x00,0xFF,0x00},
     {0x00,0xFF,0x00} ,
     {0x00,0xFF,0x00},
     {0x00,0xFF,0x00},
     {0xFF,0x00,0x00},
     {0x00,0x00,0x00,0x00}},
    {{0x00,0x00,0x00,0x00,0x00}, /* * */
     {0xFF,0x00,0xFF,0x00,0xFF},
     {0x00,0xFF,0xFF,0xFF,0x00},
     {0x00,0x00,0xFF,0x00,0x00} ,
     {0x00,0xFF,0xFF,0xFF,0x00},
     {0xFF,0x00,0xFF,0x00,0xFF},
     {0x00,0x00,0x00,0x00,0x00},
     {0x00,0x00,0x00,0x00,0x00}},
    {{0x00,0x00,0x00}, /* + */
     {0x00,0x00,0x00},
     {0x00,0xFF,0x00},
     {0xFF,0xFF,0xFF} ,
     {0x00,0xFF,0x00},
     {0x00,0x00,0x00},
     {0x00,0x00,0x00},
     {0x00,0x00,0x00}},
    {{0x00,0x00}, /* , */
     {0x00,0x00},
     {0x00,0x00},
     {0x00,0x00} ,
     {0x00,0x00},
     {0x00,0xFF},
     {0x00,0xFF},
     {0xFF,0x00}},
    {{0x00,0x00,0x00}, /* - */
     {0x00,0x00,0x00},
     {0x00,0x00,0x00},
     {0xFF,0xFF,0xFF} ,
     {0x00,0x00,0x00},
     {0x00,0x00,0x00},
     {0x00,0x00,0x00},
     {0x00,0x00,0x00}},
    {{0x00}, /* . */
     {0x00},
     {0x00},
     {0x00} ,
     {0x00},
     {0x00},
     {0xFF},
     {0x00}},
    {{0x00,0x00,0x00,0xFF}, /* / */
     {0x00,0x00,0x00,0xFF},
     {0x00,0x00,0xFF,0x00},
     {0x00,0x00,0xFF,0x00} ,
     {0x00,0xFF,0x00,0x00},
     {0x00,0xFF,0x00,0x00},
     {0xFF,0x00,0x00,0x00},
     {0xFF,0x00,0x00,0x00}},
    {{0x00,0xFF,0xFF,0x00}, /* 0 */
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0x00,0x00,0xFF} ,
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0x00,0x00,0xFF},
     {0x00,0xFF,0xFF,0x00},
     {0x00,0x00,0x00,0x00}},
    {{0x00,0xFF,0x00}, /* 1 */
     {0xFF,0xFF,0x00},
     {0x00,0xFF,0x00},
     {0x00,0xFF,0x00} ,
     {0x00,0xFF,0x00},
     {0x00,0xFF,0x00},
     {0xFF,0xFF,0xFF},
     {0x00,0x00,0x00}},
    {{0x00,0xFF,0xFF,0x00}, /* 2 */
     {0xFF,0x00,0x00,0xFF},
     {0x00,0x00,0x00,0xFF},
     {0x00,0x00,0xFF,0x00} ,
     {0x00,0xFF,0x00,0x00},
     {0xFF,0x00,0x00,0x00},
     {0xFF,0xFF,0xFF,0xFF},
     {0x00,0x00,0x00,0x00}},
    {{0xFF,0xFF,0xFF,0xFF}, /* 3 */
     {0x00,0x00,0x00,0xFF},
     {0x00,0x00,0xFF,0x00},
     {0x00,0xFF,0xFF,0x00} ,
     {0x00,0x00,0x00,0xFF},
     {0x00,0x00,0x00,0xFF},
     {0xFF,0xFF,0xFF,0x00},
     {0x00,0x00,0x00,0x00}},
    {{0x00,0x00,0xFF,0x00}, /* 4 */
     {0x00,0xFF,0xFF,0x00},
     {0xFF,0x00,0xFF,0x00},
     {0xFF,0xFF,0xFF,0xFF} ,
     {0x00,0x00,0xFF,0x00},
     {0x00,0x00,0xFF,0x00},
     {0x00,0x00,0xFF,0x00},
     {0x00,0x00,0x00,0x00}},
    {{0xFF,0xFF,0xFF,0xFF}, /* 5 */
     {0xFF,0x00,0x00,0x00},
     {0xFF,0x00,0x00,0x00},
     {0xFF,0xFF,0xFF,0x00} ,
     {0x00,0x00,0x00,0xFF},
     {0xFF,0x00,0x00,0xFF},
     {0x00,0xFF,0xFF,0x00},
     {0x00,0x00,0x00,0x00}},
    {{0x00,0xFF,0xFF,0x00}, /* 6 */
     {0xFF,0x00,0x00,0x00},
     {0xFF,0x00,0x00,0x00},
     {0xFF,0xFF,0xFF,0x00} ,
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0x00,0x00,0xFF},
     {0x00,0xFF,0xFF,0x00},
     {0x00,0x00,0x00,0x00}},
    {{0xFF,0xFF,0xFF,0xFF}, /* 7 */
     {0x00,0x00,0x00,0xFF},
     {0x00,0x00,0xFF,0x00},
     {0x00,0xFF,0x00,0x00} ,
     {0xFF,0x00,0x00,0x00},
     {0xFF,0x00,0x00,0x00},
     {0xFF,0x00,0x00,0x00},
     {0x00,0x00,0x00,0x00}},
    {{0x00,0xFF,0xFF,0x00}, /* 8 */
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0x00,0x00,0xFF},
     {0x00,0xFF,0xFF,0x00} ,
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0x00,0x00,0xFF},
     {0x00,0xFF,0xFF,0x00},
     {0x00,0x00,0x00,0x00}},
    {{0x00,0xFF,0xFF,0x00}, /* 9 */
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0x00,0x00,0xFF},
     {0x00,0xFF,0xFF,0xFF} ,
     {0x00,0x00,0x00,0xFF},
     {0x00,0x00,0x00,0xFF},
     {0x00,0xFF,0xFF,0x00},
     {0x00,0x00,0x00,0x00}},
    {{0x00}, /* : */
     {0x00},
     {0xFF},
     {0x00} ,
     {0x00},
     {0xFF},
     {0x00},
     {0x00}},
    {{0x00,0x00}, /* ; */
     {0x00,0x00},
     {0x00,0xFF},
     {0x00,0x00} ,
     {0x00,0x00},
     {0x00,0xFF},
     {0x00,0xFF},
     {0xFF,0x00}},
    {{0x00,0x00,0x00,0xFF}, /* < */
     {0x00,0x00,0xFF,0x00},
     {0x00,0xFF,0x00,0x00},
     {0xFF,0x00,0x00,0x00} ,
     {0x00,0xFF,0x00,0x00},
     {0x00,0x00,0xFF,0x00},
     {0x00,0x00,0x00,0xFF},
     {0x00,0x00,0x00,0x00}},
    {{0x00,0x00,0x00,0x00}, /* = */
     {0x00,0x00,0x00,0x00},
     {0xFF,0xFF,0xFF,0xFF},
     {0x00,0x00,0x00,0x00} ,
     {0xFF,0xFF,0xFF,0xFF},
     {0x00,0x00,0x00,0x00},
     {0x00,0x00,0x00,0x00},
     {0x00,0x00,0x00,0x00}},
    {{0xFF,0x00,0x00,0x00}, /* > */
     {0x00,0xFF,0x00,0x00},
     {0x00,0x00,0xFF,0x00},
     {0x00,0x00,0x00,0xFF} ,
     {0x00,0x00,0xFF,0x00},
     {0x00,0xFF,0x00,0x00},
     {0xFF,0x00,0x00,0x00},
     {0x00,0x00,0x00,0x00}},
    {{0x00,0xFF,0xFF,0x00}, /* ? */
     {0xFF,0x00,0x00,0xFF},
     {0x00,0x00,0x00,0xFF},
     {0x00,0x00,0xFF,0x00} ,
     {0x00,0xFF,0x00,0x00},
     {0x00,0x00,0x00,0x00},
     {0x00,0xFF,0x00,0x00},
     {0x00,0x00,0x00,0x00}},
    {{0x00,0xFF,0xFF,0x00}, /* @ */
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0x00,0xFF,0xFF},
     {0xFF,0x00,0xFF,0xFF} ,
     {0xFF,0x00,0xFF,0x00},
     {0xFF,0x00,0x00,0x00},
     {0x00,0xFF,0xFF,0xFF},
     {0x00,0x00,0x00,0x00}},
    {{0x00,0xFF,0xFF,0x00}, /* A */
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0xFF,0xFF,0xFF} ,
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0x00,0x00,0xFF},
     {0x00,0x00,0x00,0x00}},
    {{0xFF,0xFF,0xFF,0x00}, /* B */
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0xFF,0xFF,0x00} ,
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0xFF,0xFF,0x00},
     {0x00,0x00,0x00,0x00}},
    {{0x00,0xFF,0xFF,0x00},   /* C */
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0x00,0x00,0x00},
     {0xFF,0x00,0x00,0x00} ,
     {0xFF,0x00,0x00,0x00},
     {0xFF,0x00,0x00,0xFF},
     {0x00,0xFF,0xFF,0x00},
     {0x00,0x00,0x00,0x00}},
    {{0xFF,0xFF,0xFF,0x00}, /* D */
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0x00,0x00,0xFF} ,
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0xFF,0xFF,0x00},
     {0x00,0x00,0x00,0x00}},
    {{0xFF,0xFF,0xFF,0xFF}, /* E */
     {0xFF,0x00,0x00,0x00},
     {0xFF,0x00,0x00,0x00},
     {0xFF,0xFF,0xFF,0x00} ,
     {0xFF,0x00,0x00,0x00},
     {0xFF,0x00,0x00,0x00},
     {0xFF,0xFF,0xFF,0xFF},
     {0x00,0x00,0x00,0x00}},
    {{0xFF,0xFF,0xFF,0xFF}, /* F */
     {0xFF,0x00,0x00,0x00},
     {0xFF,0x00,0x00,0x00},
     {0xFF,0xFF,0xFF,0x00} ,
     {0xFF,0x00,0x00,0x00},
     {0xFF,0x00,0x00,0x00},
     {0xFF,0x00,0x00,0x00},
     {0x00,0x00,0x00,0x00}},
    {{0x00,0xFF,0xFF,0x00}, /* G */
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0x00,0x00,0x00},
     {0xFF,0x00,0xFF,0xFF} ,
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0x00,0x00,0xFF},
     {0x00,0xFF,0xFF,0x00},
     {0x00,0x00,0x00,0x00}},
    {{0xFF,0x00,0x00,0xFF}, /* H */
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0xFF,0xFF,0xFF} ,
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0x00,0x00,0xFF},
     {0x00,0x00,0x00,0x00}},
    {{0xFF,0xFF,0xFF}, /* I */
     {0x00,0xFF,0x00},
     {0x00,0xFF,0x00},
     {0x00,0xFF,0x00} ,
     {0x00,0xFF,0x00},
     {0x00,0xFF,0x00},
     {0xFF,0xFF,0xFF},
     {0x00,0x00,0x00}},
    {{0x00,0x00,0x00,0xFF}, /* J */
     {0x00,0x00,0x00,0xFF},
     {0x00,0x00,0x00,0xFF},
     {0x00,0x00,0x00,0xFF} ,
     {0x00,0x00,0x00,0xFF},
     {0xFF,0x00,0x00,0xFF},
     {0x00,0xFF,0xFF,0x00},
     {0x00,0x00,0x00,0x00}},
    {{0xFF,0x00,0x00,0xFF}, /* K */
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0x00,0xFF,0x00},
     {0xFF,0xFF,0x00,0x00} ,
     {0xFF,0x00,0xFF,0x00},
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0x00,0x00,0xFF},
     {0x00,0x00,0x00,0x00}},
    {{0xFF,0x00,0x00,0x00}, /* L */
     {0xFF,0x00,0x00,0x00},
     {0xFF,0x00,0x00,0x00},
     {0xFF,0x00,0x00,0x00} ,
     {0xFF,0x00,0x00,0x00},
     {0xFF,0x00,0x00,0x00},
     {0xFF,0xFF,0xFF,0xFF},
     {0x00,0x00,0x00,0x00}},
    {{0xFF,0x00,0x00,0x00,0xFF}, /* M */
     {0xFF,0xFF,0x00,0xFF,0xFF},
     {0xFF,0x00,0xFF,0x00,0xFF},
     {0xFF,0x00,0x00,0x00,0xFF} ,
     {0xFF,0x00,0x00,0x00,0xFF},
     {0xFF,0x00,0x00,0x00,0xFF},
     {0xFF,0x00,0x00,0x00,0xFF},
     {0x00,0x00,0x00,0x00,0x00}},
    {{0xFF,0x00,0x00,0xFF}, /* N */
     {0xFF,0xFF,0x00,0xFF},
     {0xFF,0xFF,0x00,0xFF},
     {0xFF,0x00,0xFF,0xFF} ,
     {0xFF,0x00,0xFF,0xFF},
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0x00,0x00,0xFF},
     {0x00,0x00,0x00,0x00}},
    {{0x00,0xFF,0xFF,0x00}, /* O */
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0x00,0x00,0xFF} ,
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0x00,0x00,0xFF},
     {0x00,0xFF,0xFF,0x00},
     {0x00,0x00,0x00,0x00}},
    {{0xFF,0xFF,0xFF,0x00}, /* P */
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0xFF,0xFF,0x00} ,
     {0xFF,0x00,0x00,0x00},
     {0xFF,0x00,0x00,0x00},
     {0xFF,0x00,0x00,0x00},
     {0x00,0x00,0x00,0x00}},
    {{0x00,0xFF,0xFF,0x00}, /* Q */
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0x00,0x00,0xFF} ,
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0x00,0xFF,0xFF},
     {0x00,0xFF,0xFF,0xFF},
     {0x00,0x00,0x00,0x00}},
    {{0xFF,0xFF,0xFF,0x00}, /* R */
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0xFF,0xFF,0x00} ,
     {0xFF,0xFF,0x00,0x00},
     {0xFF,0x00,0xFF,0x00},
     {0xFF,0x00,0x00,0xFF},
     {0x00,0x00,0x00,0x00}},
    {{0x00,0xFF,0xFF,0x00}, /* S */
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0x00,0x00,0x00},
     {0x00,0xFF,0xFF,0x00} ,
     {0x00,0x00,0x00,0xFF},
     {0xFF,0x00,0x00,0xFF},
     {0x00,0xFF,0xFF,0x00},
     {0x00,0x00,0x00,0x00}},
    {{0xFF,0xFF,0xFF,0xFF,0xFF}, /* T */
     {0x00,0x00,0xFF,0x00,0x00},
     {0x00,0x00,0xFF,0x00,0x00},
     {0x00,0x00,0xFF,0x00,0x00} ,
     {0x00,0x00,0xFF,0x00,0x00},
     {0x00,0x00,0xFF,0x00,0x00},
     {0x00,0x00,0xFF,0x00,0x00},
     {0x00,0x00,0x00,0x00,0x00}},
    {{0xFF,0x00,0x00,0xFF}, /* U */
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0x00,0x00,0xFF} ,
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0x00,0x00,0xFF},
     {0x00,0xFF,0xFF,0x00},
     {0x00,0x00,0x00,0x00}},
    {{0xFF,0x00,0xFF}, /* V */
     {0xFF,0x00,0xFF},
     {0xFF,0x00,0xFF},
     {0xFF,0x00,0xFF} ,
     {0xFF,0x00,0xFF},
     {0xFF,0x00,0xFF},
     {0x00,0xFF,0x00},
     {0x00,0x00,0x00}},
    {{0xFF,0x00,0x00,0x00,0xFF}, /* W */
     {0xFF,0x00,0x00,0x00,0xFF},
     {0xFF,0x00,0x00,0x00,0xFF},
     {0xFF,0x00,0x00,0x00,0xFF} ,
     {0xFF,0x00,0xFF,0x00,0xFF},
     {0xFF,0x00,0xFF,0x00,0xFF},
     {0x00,0xFF,0x00,0xFF,0x00},
     {0x00,0x00,0x00,0x00,0x00}},
    {{0xFF,0x00,0xFF}, /* X */
     {0xFF,0x00,0xFF},
     {0xFF,0x00,0xFF},
     {0x00,0xFF,0x00} ,
     {0xFF,0x00,0xFF},
     {0xFF,0x00,0xFF},
     {0xFF,0x00,0xFF},
     {0x00,0x00,0x00}},
    {{0xFF,0x00,0xFF}, /* Y */
     {0xFF,0x00,0xFF},
     {0xFF,0x00,0xFF},
     {0x00,0xFF,0x00} ,
     {0x00,0xFF,0x00},
     {0x00,0xFF,0x00},
     {0x00,0xFF,0x00},
     {0x00,0x00,0x00}},
    {{0xFF,0xFF,0xFF,0xFF}, /* Z */
     {0x00,0x00,0x00,0xFF},
     {0x00,0x00,0xFF,0x00},
     {0x00,0x00,0xFF,0x00} ,
     {0x00,0xFF,0x00,0x00},
     {0xFF,0x00,0x00,0x00},
     {0xFF,0xFF,0xFF,0xFF},
     {0x00,0x00,0x00,0x00}},
    {{0x00,0xFF,0xFF}, /* [ */
     {0x00,0xFF,0x00},
     {0x00,0xFF,0x00},
     {0x00,0xFF,0x00} ,
     {0x00,0xFF,0x00},
     {0x00,0xFF,0x00},
     {0x00,0xFF,0xFF},
     {0x00,0x00,0x00,0x00}},
    {{0xFF,0x00,0x00,0x00}, /* \ */
     {0xFF,0x00,0x00,0x00},
     {0x00,0xFF,0x00,0x00},
     {0x00,0xFF,0x00,0x00} ,
     {0x00,0x00,0xFF,0x00},
     {0x00,0x00,0xFF,0x00},
     {0x00,0x00,0x00,0xFF},
     {0x00,0x00,0x00,0xFF}},
    {{0x00,0xFF,0xFF}, /* ] */
     {0x00,0x00,0xFF},
     {0x00,0x00,0xFF},
     {0x00,0x00,0xFF} ,
     {0x00,0x00,0xFF},
     {0x00,0x00,0xFF},
     {0x00,0xFF,0xFF},
     {0x00,0x00,0x00}},
    {{0x00,0xFF,0x00}, /* ^ */
     {0xFF,0x00,0xFF},
     {0x00,0x00,0x00},
     {0x00,0x00,0x00} ,
     {0x00,0x00,0x00},
     {0x00,0x00,0x00},
     {0x00,0x00,0x00},
     {0x00,0x00,0x00}},
    {{0x00,0x00,0x00}, /* _ */
     {0x00,0x00,0x00},
     {0x00,0x00,0x00},
     {0x00,0x00,0x00} ,
     {0x00,0x00,0x00},
     {0x00,0x00,0x00},
     {0xFF,0xFF,0xFF,0xFF},
     {0x00,0x00,0x00,0x00}},
    {{0x00,0xFF,0x00}, /* ` */
     {0x00,0xFF,0x00},
     {0x00,0x00,0xFF},
     {0x00,0x00,0xFF} ,
     {0x00,0x00,0x00},
     {0x00,0x00,0x00},
     {0x00,0x00,0x00},
     {0x00,0x00,0x00}},
    {{0x00,0x00,0x00,0x00}, /* a */
     {0x00,0x00,0x00,0x00},
     {0x00,0x00,0x00,0x00},
     {0x00,0xFF,0xFF,0x00} ,
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0x00,0x00,0xFF},
     {0x00,0xFF,0xFF,0xFF},
     {0x00,0x00,0x00,0x00}},
    {{0x00,0x00,0x00,0x00}, /* b */
     {0xFF,0x00,0x00,0x00},
     {0xFF,0x00,0x00,0x00},
     {0xFF,0xFF,0xFF,0x00} ,
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0xFF,0xFF,0x00},
     {0x00,0x00,0x00,0x00}},
    {{0x00,0x00,0x00,0x00}, /* c */
     {0x00,0x00,0x00,0x00},
     {0x00,0x00,0x00,0x00},
     {0x00,0xFF,0xFF,0x00} ,
     {0xFF,0x00,0x00,0x00},
     {0xFF,0x00,0x00,0x00},
     {0x00,0xFF,0xFF,0x00},
     {0x00,0x00,0x00,0x00}},
    {{0x00,0x00,0x00,0x00}, /* d */
     {0x00,0x00,0x00,0xFF},
     {0x00,0x00,0x00,0xFF},
     {0x00,0xFF,0xFF,0xFF} ,
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0x00,0x00,0xFF},
     {0x00,0xFF,0xFF,0xFF},
     {0x00,0x00,0x00,0x00}},
    {{0x00,0x00,0x00,0x00}, /* e */
     {0x00,0x00,0x00,0x00},
     {0x00,0x00,0x00,0x00},
     {0x00,0xFF,0xFF,0x00} ,
     {0xFF,0xFF,0xFF,0xFF},
     {0xFF,0x00,0x00,0x00},
     {0x00,0xFF,0xFF,0x00},
     {0x00,0x00,0x00,0x00}},
    {{0x00,0x00,0xFF,0x00}, /* f */
     {0x00,0xFF,0x00,0xFF},
     {0x00,0xFF,0x00,0x00},
     {0xFF,0xFF,0xFF,0x00} ,
     {0x00,0xFF,0x00,0x00},
     {0x00,0xFF,0x00,0x00},
     {0x00,0xFF,0x00,0x00},
     {0x00,0x00,0x00,0x00}},
    {{0x00,0x00,0x00,0x00}, /* g */
     {0x00,0x00,0x00,0x00},
     {0x00,0x00,0x00,0x00},
     {0x00,0xFF,0xFF,0x00} ,
     {0xFF,0x00,0x00,0xFF},
     {0x00,0xFF,0xFF,0xFF},
     {0x00,0x00,0x00,0xFF},
     {0x00,0xFF,0xFF,0x00}},
    {{0x00,0x00,0x00,0x00}, /* h */
     {0xFF,0x00,0x00,0x00},
     {0xFF,0x00,0x00,0x00},
     {0xFF,0xFF,0xFF,0x00} ,
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0x00,0x00,0xFF},
     {0x00,0x00,0x00,0x00}},
    {{0x00,0x00,0x00}, /* i */
     {0x00,0xFF,0x00},
     {0x00,0x00,0x00},
     {0xFF,0xFF,0x00} ,
     {0x00,0xFF,0x00},
     {0x00,0xFF,0x00},
     {0xFF,0xFF,0xFF},
     {0x00,0x00,0x00,0x00}},
    {{0x00,0x00,0x00,0x00}, /* j */
     {0x00,0x00,0xFF,0x00},
     {0x00,0x00,0x00,0x00},
     {0x00,0x00,0xFF,0x00} ,
     {0x00,0x00,0xFF,0x00},
     {0x00,0x00,0xFF,0x00},
     {0xFF,0x00,0xFF,0x00},
     {0x00,0xFF,0x00,0x00}},
    {{0x00,0x00,0x00,0x00}, /* k */
     {0xFF,0x00,0x00,0x00},
     {0xFF,0x00,0x00,0x00},
     {0xFF,0x00,0x00,0xFF} ,
     {0xFF,0xFF,0xFF,0x00},
     {0xFF,0x00,0xFF,0x00},
     {0xFF,0x00,0x00,0xFF},
     {0x00,0x00,0x00,0x00}},
    {{0xFF,0xFF,0x00}, /* l */
     {0x00,0xFF,0x00},
     {0x00,0xFF,0x00},
     {0x00,0xFF,0x00} ,
     {0x00,0xFF,0x00},
     {0x00,0xFF,0x00},
     {0xFF,0xFF,0xFF},
     {0x00,0x00,0x00}},
    {{0x00,0x00,0x00,0x00,0x00}, /* m */
     {0x00,0x00,0x00,0x00,0x00},
     {0x00,0x00,0x00,0x00,0x00},
     {0xFF,0xFF,0x00,0xFF,0x00} ,
     {0xFF,0x00,0xFF,0x00,0xFF},
     {0xFF,0x00,0xFF,0x00,0xFF},
     {0xFF,0x00,0xFF,0x00,0xFF},
     {0x00,0x00,0x00,0x00,0x00}},
    {{0x00,0x00,0x00,0x00}, /* n */
     {0x00,0x00,0x00,0x00},
     {0x00,0x00,0x00,0x00},
     {0xFF,0x00,0xFF,0x00} ,
     {0xFF,0xFF,0x00,0xFF},
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0x00,0x00,0xFF},
     {0x00,0x00,0x00,0x00}},
    {{0x00,0x00,0x00,0x00}, /* o */
     {0x00,0x00,0x00,0x00},
     {0x00,0x00,0x00,0x00},
     {0x00,0xFF,0xFF,0x00} ,
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0x00,0x00,0xFF},
     {0x00,0xFF,0xFF,0x00},
     {0x00,0x00,0x00,0x00}},
    {{0x00,0x00,0x00,0x00}, /* p */
     {0x00,0x00,0x00,0x00},
     {0x00,0x00,0x00,0x00},
     {0xFF,0xFF,0xFF,0x00} ,
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0xFF,0xFF,0x00},
     {0xFF,0x00,0x00,0x00}},
    {{0x00,0x00,0x00,0x00}, /* q */
     {0x00,0x00,0x00,0x00},
     {0x00,0x00,0x00,0x00},
     {0x00,0xFF,0xFF,0xFF} ,
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0x00,0x00,0xFF},
     {0x00,0xFF,0xFF,0xFF},
     {0x00,0x00,0x00,0xFF}},
    {{0x00,0x00,0x00,0x00}, /* r */
     {0x00,0x00,0x00,0x00},
     {0x00,0x00,0x00,0x00},
     {0xFF,0x00,0xFF,0xFF} ,
     {0xFF,0xFF,0x00,0x00},
     {0xFF,0x00,0x00,0x00},
     {0xFF,0x00,0x00,0x00},
     {0x00,0x00,0x00,0x00}},
    {{0x00,0x00,0x00,0x00}, /* s */
     {0x00,0x00,0x00,0x00},
     {0x00,0x00,0x00,0x00},
     {0x00,0xFF,0xFF,0x00} ,
     {0xFF,0xFF,0xFF,0x00},
     {0x00,0x00,0x00,0xFF},
     {0x00,0xFF,0xFF,0x00},
     {0x00,0x00,0x00,0x00}},
    {{0x00,0x00,0x00}, /* t */
     {0x00,0x00,0x00},
     {0x00,0xFF,0x00},
     {0xFF,0xFF,0xFF} ,
     {0x00,0xFF,0x00},
     {0x00,0xFF,0x00},
     {0x00,0xFF,0x00},
     {0x00,0x00,0x00}},
    {{0x00,0x00,0x00,0x00}, /* u */
     {0x00,0x00,0x00,0x00},
     {0x00,0x00,0x00,0x00},
     {0xFF,0x00,0x00,0xFF} ,
     {0xFF,0x00,0x00,0xFF},
     {0xFF,0x00,0x00,0xFF},
     {0x00,0xFF,0xFF,0xFF},
     {0x00,0x00,0x00,0x00}},
    {{0x00,0x00,0x00}, /* v */
     {0x00,0x00,0x00},
     {0x00,0x00,0x00},
     {0xFF,0x00,0xFF} ,
     {0xFF,0x00,0xFF},
     {0xFF,0x00,0xFF},
     {0x00,0xFF,0x00},
     {0x00,0x00,0x00}},
    {{0x00,0x00,0x00,0x00,0x00}, /* w */
     {0x00,0x00,0x00,0x00,0x00},
     {0x00,0x00,0x00,0x00,0x00},
     {0xFF,0x00,0x00,0x00,0xFF} ,
     {0xFF,0x00,0x00,0x00,0xFF},
     {0xFF,0x00,0xFF,0x00,0xFF},
     {0x00,0xFF,0x00,0xFF,0x00},
     {0x00,0x00,0x00,0x00,0x00}},
    {{0x00,0x00,0x00}, /* x */
     {0x00,0x00,0x00},
     {0x00,0x00,0x00},
     {0xFF,0x00,0xFF} ,
     {0x00,0xFF,0x00},
     {0x00,0xFF,0x00},
     {0xFF,0x00,0xFF},
     {0x00,0x00,0x00}},
    {{0x00,0x00,0x00,0x00}, /* y */
     {0x00,0x00,0x00,0x00},
     {0x00,0x00,0x00,0x00},
     {0xFF,0x00,0x00,0xFF} ,
     {0xFF,0x00,0x00,0xFF},
     {0x00,0xFF,0xFF,0xFF},
     {0x00,0x00,0x00,0xFF},
     {0x00,0xFF,0xFF,0x00}},
    {{0x00,0x00,0x00,0x00}, /* z */
     {0x00,0x00,0x00,0x00},
     {0x00,0x00,0x00,0x00},
     {0xFF,0xFF,0xFF,0xFF} ,
     {0x00,0x00,0xFF,0x00},
     {0x00,0xFF,0x00,0x00},
     {0xFF,0xFF,0xFF,0xFF},
     {0x00,0x00,0x00,0x00}},
    {{0x00,0x00,0xFF}, /* { */
     {0x00,0xFF,0x00},
     {0x00,0xFF,0x00},
     {0xFF,0x00,0x00} ,
     {0x00,0xFF,0x00},
     {0x00,0xFF,0x00},
     {0x00,0x00,0xFF},
     {0x00,0x00,0x00}},
    {{0x00,0xFF}, /* | */
     {0x00,0xFF},
     {0x00,0xFF},
     {0x00,0xFF} ,
     {0x00,0xFF},
     {0x00,0xFF},
     {0x00,0xFF},
     {0x00,0xFF}},
    {{0xFF,0x00,0x00}, /* } */
     {0x00,0xFF,0x00},
     {0x00,0xFF,0x00},
     {0x00,0x00,0xFF} ,
     {0x00,0xFF,0x00},
     {0x00,0xFF,0x00},
     {0xFF,0x00,0x00},
     {0x00,0x00,0x00}},
    {{0x00,0x00,0x00,0x00,0x00}, /* ~ */
     {0x11,0x00,0x00,0x00,0x11},
     {0x00,0x00,0x00,0x00,0x00},
     {0x00,0x00,0x11,0x00,0x00} ,
     {0x00,0x00,0x00,0x00,0x00},
     {0x11,0x00,0x00,0x00,0x11},
     {0x00,0x11,0x11,0x11,0x00},
     {0x00,0x00,0x00,0x00,0x00}}
}; /* END OF FONT ! */

unsigned int VRAMOffsets[NumY][NumX]={
    {0x3F40, 0x3F44, 0x3F48, 0x3F4C, 0x3F50, 0x3F54, 0x3F58, 0x3F5C, 0x3F60, 
    0x3F64, 0x3F68, 0x3F6C, 0x3F70, 0x3F74, 0x3F78, 0x3F7C, 0x3F80, 0x3F84, 
    0x3F88, 0x3F8C, 0x3F90, 0x3F94, 0x3F98, 0x3F9C, 0x3FA0, 0x3FA4, 0x3FA8, 
    0x3FAC, 0x3FB0, 0x3FB4, 0x3FB8, 0x3FBC, 0x3FC0, 0x3FC4, 0x3FC8, 0x3FCC, 
    0x3FD0, 0x3FD4, 0x3FD8, 0x3FDC},
    {0x4440, 0x4444, 0x4448, 0x444C, 0x4450, 0x4454, 0x4458, 0x445C, 0x4460, 
    0x4464, 0x4468, 0x446C, 0x4470, 0x4474, 0x4478, 0x447C, 0x4480, 0x4484, 
    0x4488, 0x448C, 0x4490, 0x4494, 0x4498, 0x449C, 0x44A0, 0x44A4, 0x44A8, 
    0x44AC, 0x44B0, 0x44B4, 0x44B8, 0x44BC, 0x44C0, 0x44C4, 0x44C8, 0x44CC, 
    0x44D0, 0x44D4, 0x44D8, 0x44DC},
    {0x4940, 0x4944, 0x4948, 0x494C, 0x4950, 0x4954, 0x4958, 0x495C, 0x4960, 
    0x4964, 0x4968, 0x496C, 0x4970, 0x4974, 0x4978, 0x497C, 0x4980, 0x4984, 
    0x4988, 0x498C, 0x4990, 0x4994, 0x4998, 0x499C, 0x49A0, 0x49A4, 0x49A8, 
    0x49AC, 0x49B0, 0x49B4, 0x49B8, 0x49BC, 0x49C0, 0x49C4, 0x49C8, 0x49CC, 
    0x49D0, 0x49D4, 0x49D8, 0x49DC},
    {0x4E40, 0x4E44, 0x4E48, 0x4E4C, 0x4E50, 0x4E54, 0x4E58, 0x4E5C, 0x4E60, 
    0x4E64, 0x4E68, 0x4E6C, 0x4E70, 0x4E74, 0x4E78, 0x4E7C, 0x4E80, 0x4E84, 
    0x4E88, 0x4E8C, 0x4E90, 0x4E94, 0x4E98, 0x4E9C, 0x4EA0, 0x4EA4, 0x4EA8, 
    0x4EAC, 0x4EB0, 0x4EB4, 0x4EB8, 0x4EBC, 0x4EC0, 0x4EC4, 0x4EC8, 0x4ECC, 
    0x4ED0, 0x4ED4, 0x4ED8, 0x4EDC},
    {0x5340, 0x5344, 0x5348, 0x534C, 0x5350, 0x5354, 0x5358, 0x535C, 0x5360, 
    0x5364, 0x5368, 0x536C, 0x5370, 0x5374, 0x5378, 0x537C, 0x5380, 0x5384, 
    0x5388, 0x538C, 0x5390, 0x5394, 0x5398, 0x539C, 0x53A0, 0x53A4, 0x53A8, 
    0x53AC, 0x53B0, 0x53B4, 0x53B8, 0x53BC, 0x53C0, 0x53C4, 0x53C8, 0x53CC, 
    0x53D0, 0x53D4, 0x53D8, 0x53DC},
    {0x5840, 0x5844, 0x5848, 0x584C, 0x5850, 0x5854, 0x5858, 0x585C, 0x5860, 
    0x5864, 0x5868, 0x586C, 0x5870, 0x5874, 0x5878, 0x587C, 0x5880, 0x5884, 
    0x5888, 0x588C, 0x5890, 0x5894, 0x5898, 0x589C, 0x58A0, 0x58A4, 0x58A8, 
    0x58AC, 0x58B0, 0x58B4, 0x58B8, 0x58BC, 0x58C0, 0x58C4, 0x58C8, 0x58CC, 
    0x58D0, 0x58D4, 0x58D8, 0x58DC},
    {0x5D40, 0x5D44, 0x5D48, 0x5D4C, 0x5D50, 0x5D54, 0x5D58, 0x5D5C, 0x5D60, 
    0x5D64, 0x5D68, 0x5D6C, 0x5D70, 0x5D74, 0x5D78, 0x5D7C, 0x5D80, 0x5D84, 
    0x5D88, 0x5D8C, 0x5D90, 0x5D94, 0x5D98, 0x5D9C, 0x5DA0, 0x5DA4, 0x5DA8, 
    0x5DAC, 0x5DB0, 0x5DB4, 0x5DB8, 0x5DBC, 0x5DC0, 0x5DC4, 0x5DC8, 0x5DCC, 
    0x5DD0, 0x5DD4, 0x5DD8, 0x5DDC},
    {0x6240, 0x6244, 0x6248, 0x624C, 0x6250, 0x6254, 0x6258, 0x625C, 0x6260, 
    0x6264, 0x6268, 0x626C, 0x6270, 0x6274, 0x6278, 0x627C, 0x6280, 0x6284, 
    0x6288, 0x628C, 0x6290, 0x6294, 0x6298, 0x629C, 0x62A0, 0x62A4, 0x62A8, 
    0x62AC, 0x62B0, 0x62B4, 0x62B8, 0x62BC, 0x62C0, 0x62C4, 0x62C8, 0x62CC, 
    0x62D0, 0x62D4, 0x62D8, 0x62DC},
    {0x6740, 0x6744, 0x6748, 0x674C, 0x6750, 0x6754, 0x6758, 0x675C, 0x6760, 
    0x6764, 0x6768, 0x676C, 0x6770, 0x6774, 0x6778, 0x677C, 0x6780, 0x6784, 
    0x6788, 0x678C, 0x6790, 0x6794, 0x6798, 0x679C, 0x67A0, 0x67A4, 0x67A8, 
    0x67AC, 0x67B0, 0x67B4, 0x67B8, 0x67BC, 0x67C0, 0x67C4, 0x67C8, 0x67CC, 
    0x67D0, 0x67D4, 0x67D8, 0x67DC}
};

unsigned int EEVRAMOffsets[NumY][NumX]={
    {0x3F40, 0x4084, 0x41C8, 0x430C, 0x43B0, 0x43B4, 0x43B8, 0x427C, 0x4140, 
    0x4004, 0x3EC8, 0x3CEC, 0x3BB0, 0x3B14, 0x3B18, 0x3B1C, 0x3BC0, 0x3D04, 
    0x3E48, 0x3F8C, 0x40D0, 0x42B4, 0x4358, 0x43FC, 0x4400, 0x4404, 0x42C8, 
    0x418C, 0x3FB0, 0x3F14, 0x3D38, 0x3BFC, 0x3B60, 0x3B64, 0x3B68, 0x3C0C, 
    0x3D50, 0x3F34, 0x3FD8, 0x41BC},
    {0x4440, 0x4584, 0x46C8, 0x480C, 0x48B0, 0x48B4, 0x48B8, 0x477C, 0x4640, 
    0x4504, 0x43C8, 0x41EC, 0x40B0, 0x4014, 0x4018, 0x401C, 0x40C0, 0x4204, 
    0x4348, 0x448C, 0x45D0, 0x47B4, 0x4858, 0x48FC, 0x4900, 0x4904, 0x47C8, 
    0x468C, 0x44B0, 0x4414, 0x4238, 0x40FC, 0x4060, 0x4064, 0x4068, 0x410C, 
    0x4250, 0x4434, 0x44D8, 0x46BC},
    {0x4940, 0x4A84, 0x4BC8, 0x4D0C, 0x4DB0, 0x4DB4, 0x4DB8, 0x4C7C, 0x4B40, 
    0x4A04, 0x48C8, 0x46EC, 0x45B0, 0x4514, 0x4518, 0x451C, 0x45C0, 0x4704, 
    0x4848, 0x498C, 0x4AD0, 0x4CB4, 0x4D58, 0x4DFC, 0x4E00, 0x4E04, 0x4CC8, 
    0x4B8C, 0x49B0, 0x4914, 0x4738, 0x45FC, 0x4560, 0x4564, 0x4568, 0x460C, 
    0x4750, 0x4934, 0x49D8, 0x4BBC},
    {0x4E40, 0x4F84, 0x50C8, 0x520C, 0x52B0, 0x52B4, 0x52B8, 0x517C, 0x5040, 
    0x4F04, 0x4DC8, 0x4BEC, 0x4AB0, 0x4A14, 0x4A18, 0x4A1C, 0x4AC0, 0x4C04, 
    0x4D48, 0x4E8C, 0x4FD0, 0x51B4, 0x5258, 0x52FC, 0x5300, 0x5304, 0x51C8, 
    0x508C, 0x4EB0, 0x4E14, 0x4C38, 0x4AFC, 0x4A60, 0x4A64, 0x4A68, 0x4B0C, 
    0x4C50, 0x4E34, 0x4ED8, 0x50BC},
    {0x5340, 0x5484, 0x55C8, 0x570C, 0x57B0, 0x57B4, 0x57B8, 0x567C, 0x5540, 
    0x5404, 0x52C8, 0x50EC, 0x4FB0, 0x4F14, 0x4F18, 0x4F1C, 0x4FC0, 0x5104, 
    0x5248, 0x538C, 0x54D0, 0x56B4, 0x5758, 0x57FC, 0x5800, 0x5804, 0x56C8, 
    0x558C, 0x53B0, 0x5314, 0x5138, 0x4FFC, 0x4F60, 0x4F64, 0x4F68, 0x500C, 
    0x5150, 0x5334, 0x53D8, 0x55BC},
    {0x5840, 0x5984, 0x5AC8, 0x5C0C, 0x5CB0, 0x5CB4, 0x5CB8, 0x5B7C, 0x5A40, 
    0x5904, 0x57C8, 0x55EC, 0x54B0, 0x5414, 0x5418, 0x541C, 0x54C0, 0x5604, 
    0x5748, 0x588C, 0x59D0, 0x5BB4, 0x5C58, 0x5CFC, 0x5D00, 0x5D04, 0x5BC8, 
    0x5A8C, 0x58B0, 0x5814, 0x5638, 0x54FC, 0x5460, 0x5464, 0x5468, 0x550C, 
    0x5650, 0x5834, 0x58D8, 0x5ABC},
    {0x5D40, 0x5E84, 0x5FC8, 0x610C, 0x61B0, 0x61B4, 0x61B8, 0x607C, 0x5F40, 
    0x5E04, 0x5CC8, 0x5AEC, 0x59B0, 0x5914, 0x5918, 0x591C, 0x59C0, 0x5B04, 
    0x5C48, 0x5D8C, 0x5ED0, 0x60B4, 0x6158, 0x61FC, 0x6200, 0x6204, 0x60C8, 
    0x5F8C, 0x5DB0, 0x5D14, 0x5B38, 0x59FC, 0x5960, 0x5964, 0x5968, 0x5A0C, 
    0x5B50, 0x5D34, 0x5DD8, 0x5FBC},
    {0x6240, 0x6384, 0x64C8, 0x660C, 0x66B0, 0x66B4, 0x66B8, 0x657C, 0x6440, 
    0x6304, 0x61C8, 0x5FEC, 0x5EB0, 0x5E14, 0x5E18, 0x5E1C, 0x5EC0, 0x6004, 
    0x6148, 0x628C, 0x63D0, 0x65B4, 0x6658, 0x66FC, 0x6700, 0x6704, 0x65C8, 
    0x648C, 0x62B0, 0x6214, 0x6038, 0x5EFC, 0x5E60, 0x5E64, 0x5E68, 0x5F0C, 
    0x6050, 0x6234, 0x62D8, 0x64BC},
    {0x6740, 0x6884, 0x69C8, 0x6B0C, 0x6BB0, 0x6BB4, 0x6BB8, 0x6A7C, 0x6940, 
    0x6804, 0x66C8, 0x64EC, 0x63B0, 0x6314, 0x6318, 0x631C, 0x63C0, 0x6504, 
    0x6648, 0x678C, 0x68D0, 0x6AB4, 0x6B58, 0x6BFC, 0x6C00, 0x6C04, 0x6AC8, 
    0x698C, 0x67B0, 0x6714, 0x6538, 0x63FC, 0x6360, 0x6364, 0x6368, 0x640C, 
    0x6550, 0x6734, 0x67D8, 0x69BC}
};
